/* Track data types */

const MAX_SECTIONS	= 255;
const MAX_NODES		= 255;
const SIZE_TRACKCONFIG = 255;


struct Section
{
	unsigned long ID;
	unsigned long OwnerID;

	double Ax;
	double Ay;
	
	double Bx;
	double By;

	unsigned long NodeA;
	unsigned long NodeB;

	double Radius;
	
	bool Active;

};

struct Node
{
	unsigned long ID;
	unsigned long OwnerID;

	unsigned long To;
	
	unsigned long SwitchGroup;
	bool Active;
};

class Track
{
private:
	unsigned long SectionCount;
	unsigned long NodeCount;

	Section sections[MAX_SECTIONS];
	Node nodes[MAX_NODES];

	


	PostDataToServer();

public:
	
	bool LoadConfigFromFile(char * filename);
	Section GetSectionById(unsigned long ID);
	Node GetNodeById(unsigned long ID);

	Section GetSectionByIndex(unsigned long index);
	Node GetNodeByIndex(unsigned long index);
	
	unsigned long GetSectionCount();
	unsigned long GetNodeCount();

		
	bool AddSection(unsigned long	id,
					double			ax,
					double			ay,
					double			bx,
					double			by,
					double			radius,
					unsigned long	nodeA,
					unsigned long	nodeB);

	bool AddNode(	unsigned long	id,
					unsigned long	to);


	Track();
	~Track();

};

struct Train
{
	unsigned long id;
	unsigned long speed;
	bool direction;
	bool slope;
	unsigned long section;
	double sectionpos;
	double x;
	double y;
};

struct Resource
{
	char type;
	unsigned long id;
	unsigned long owner;
	bool active;
};
	
	
	
	
	
	
	
