/* TOS Track Data Manager */

#include<windows.h>
#include<iostream.h>
#include<fstream.h>

#include<time.h>
#include<string.h>


#include"../TOS CLIENT API/track.h"
#include"../TOS CLIENT API/KMP_CLIENT_API.H"
#include"../TOS CLIENT API/TOS_API.h"


const char CONFIGFILE[10] = "track.def";
const char LOGFILE[13] = "TrackMan.log";
const char CLIENTNAME[9] = "TrackMan";

const unsigned long MAX_UPDATE_USERS=16;
const CYCLESLEEP =  1000;

void WriteLog(char * message);

void main()
{
	/* Connect to the server */

	char PipeName[255];
	strcpy(PipeName, "\\\\.\\pipe\\");
	strcat(PipeName, CLIENTNAME);


	//HANDLE pipe;
	HANDLE pipe = ConnectToServer(PipeName);

	if(pipe == INVALID_HANDLE_VALUE)
	{	
		WriteLog("Failed to connect to server.");
		return;
	}
	

	/* Config File */
	char ConfigFile[255];
	strncpy(ConfigFile, CONFIGFILE, 255);	


	/* UPDATE USERS */
	char UpdateUsers[MAX_UPDATE_USERS][CLIENT_SIZE_CLIENTNAME];
	unsigned long UpdateUsersCnt = 0;
	
	
	/* Define Track Class */
	Track theTrack;
	
	theTrack.LoadConfigFromFile(ConfigFile);

	while(true)
	{

		char From[CLIENT_SIZE_CLIENTNAME];
		unsigned long ServiceCode;
		char MessageData[CLIENT_SIZE_MESSAGE];
		unsigned long MessageLength;

		char logmessage[255];
		char filename[255];

		/* Get Next Message From Queue */
		int ret = GetMessageFromPeer(From, ServiceCode, MessageData, MessageLength, pipe);

		if(ret == -2)
		{
			/* Read/Write Failed, pipe may be broken or server closed */
			return;
		}

		cerr << ".....\n";

		if(ret >= 0)
		{
			/* TRACK MAN SERVICE CODES                           */
			/* Defined In TOS_API.H								 */

			cerr << "Recieved";

			switch( ServiceCode )
			{
			case SC_REQUEST_TRACK_DATA:

				/* Request Track Definitions */

				if(TOS_SendTrackData(&theTrack, From, pipe))
				{
					strcpy(logmessage, "Track data sent to ");
					strcat(logmessage, From);
					WriteLog(logmessage);
				}
				else
				{
					strcpy(logmessage, "Track data failed to sent to ");
					strcat(logmessage, From);
					WriteLog(logmessage);
				}

				break;

			case SC_REQUEST_TRACK_DATA_UPDATES:
				/* Add sender to update list */

				if(UpdateUsersCnt >= MAX_UPDATE_USERS)
				{
					break;
				}

				strncpy(UpdateUsers[UpdateUsersCnt], From, CLIENT_SIZE_CLIENTNAME);
				UpdateUsersCnt++;

				break;
			case SC_LOAD_TRACK_FROM_FILE:

				
				/* Load Track Definition From File and update clients in list */
				MessageData[MessageLength] = 0;
				
				strncpy(filename, MessageData, 255);

				theTrack.LoadConfigFromFile(filename);

				/* Update registered users */

				if(TOS_SendTrackData(&theTrack, UpdateUsers, UpdateUsersCnt, pipe))
				{
					strcpy(logmessage, "Track data sent to all registerd clients.");
					
					WriteLog(logmessage);
				}
				else
				{
					strcpy(logmessage, "Track data failed to sent to all registered clients.");
					
					WriteLog(logmessage);
				}
			

				break;

			default:
				/* UNRECOGNIZED COMMAND - Do nothing */

				break;
			}
		}
		/* Release CPU */
		Sleep(CYCLESLEEP);
	}
}


void WriteLog(char * message)
{

	char LogFile[255];
	strcpy(LogFile, LOGFILE);

	ofstream log;
	log.open(LogFile,ios::app);

	cerr << message << "\n";

	if(!log)
	{
		cerr << "Failed to write to log.\n";
		return;
	}
    char dbuffer [9];
    char tbuffer [9];
    _strdate( dbuffer );
    _strtime( tbuffer );
    

	log << dbuffer << " " << tbuffer << " - " << message << "\n";

	return;

}








