/* Train Manager */

#include<iostream.h>
#include<fstream.h>
#include<windows.h>
#include<stdio.h>
#include<time.h>

/* for ftime */
#include<sys/types.h>
#include<sys/timeb.h>

#include"..\TOS CLIENT API\track.h"
#include"..\TOS CLIENT API\kmp_client_api.h"
#include"..\TOS CLIENT API\tos_api.h"


char MyClientName[] = "TrainMan";
char MyPipeName[]   = "\\\\.\\pipe\\TrainMan";
char LOGFILE[] = "TrainMan.log";



const MAX_TRAINS		= 20;
const MAX_UPDATE_USERS	= 10;
const FULLSPEED			= 100;    /* 10cm /s */
const FULLDCCSPEED		= 14;
const ACC				= 10;  /* 1cm /s/s */

struct UpdateUser
{
	char ClientName[CLIENT_SIZE_CLIENTNAME];
	unsigned long interval;
	unsigned long lastupdate;
};

void WriteLog(char * message);
bool SetTrainSpeed(char * data, unsigned long length, Train * trains, unsigned long traincnt);
bool AddUpdatesUser(char  users[][CLIENT_SIZE_CLIENTNAME], unsigned long& usercnt, char * from, char * data, unsigned long length);
bool AddTrain(Train * trains, unsigned long& traincnt, char * data, unsigned long length);
bool RemoveTrain(Train * trains, unsigned long traincnt, char * data, unsigned long length);


void main()
{

	/* Train Manager Startup

	/* Connect to the server */

	HANDLE pipe = ConnectToServer(MyPipeName);
	
	if(pipe == INVALID_HANDLE_VALUE)
	{
		WriteLog("Could Not Connect, exiting.\n");
		return;
	}



	/* Track Data */
	Track myTrack;

	/* Train Data */
	Train trains[MAX_TRAINS];
	unsigned long traincnt = 0;

	/* Array for users registered for updates */
	char users[MAX_UPDATE_USERS][CLIENT_SIZE_CLIENTNAME];
	unsigned long userinterval [MAX_UPDATE_USERS];
	unsigned long usercnt = 0;



	/* Post Request For Track Data First */
	TOS_RequestTrackData(pipe);
	
	/* some common variables */
	char From[CLIENT_SIZE_CLIENTNAME];
	unsigned long ServiceCode;
	char MessageData[CLIENT_SIZE_MESSAGE];
	unsigned long MessageLength;

	/* timing vairiable */
	struct _timeb lasttime;
	struct _timeb thistime;
	double diff;


	/* fill time struct */
    _ftime( &lasttime );
	_ftime( &thistime );


	char logmessage[255];

	/* StartMainLoop */
	while(true)
	{


		/* calculate time difference in ms */
		//_ftime( &thistime );
		//diff = (thistime.time - lasttime.time);

		/* these calculations are being skipped for now,             */
		/* i'm implementing a simpler algorithm for the presentation */

		//if(thistime.millitm < lasttime.millitm)
		//{
		//	diff += (1000 - lasttime.millitm + thistime.millitm) * .001;
		//}
		//else
		//{
		//	diff += (thistime.millitm - lasttime.millitm) * .001;
		//}

		/* end time diff calculation */

		//if(traincnt > 0)
		//{
		//	/* Update train data */
		//	unsigned int i;
	 	//	for(i=0;i<traincnt;i++)
		//	{
		//		/* Update train positions */
		//		if(trains[i].speed != trains[i].targetspeed)
		//		{
		//			/* Calculate new speed with acceleration */
		//			/* v = at */
		//			trains[i].speed += (ACC * diff);
		//			if( trains[i].speed > trains[i].targetspeed)
		//			{
		//				trains[i].speed = trains[i].targetspeed;
		//			}
		//		}
		//
		//		Section sec = myTrack.GetSectionById(trains[i].section);
		//
		//
		//		/* update posistion */
		//		/* x = vt */
		//		
		//		/* left off here */
//
//			}
//
//		}
//
/* end skipped code */


		/* Get Next Message From Queue */
		int ret = GetMessageFromPeer(From, ServiceCode, MessageData, MessageLength, pipe);

		Resource * res = NULL;

		if(ret >= 0)
		{

			/*DETERMINE MESSAGE TYPE*/
			switch(ServiceCode)
			{
			case SC_SET_TRAIN_SPEED:
				/*Set the speed and direction of a train*/
				SetTrainSpeed(MessageData, MessageLength, trains, traincnt);
				break;	
			case SC_SET_TRAIN_ACCESSORY:
				/*Skippin this function for now */
				break;
			case SC_REQUEST_TRAIN_UPDATES:
				/* Add sender to list for updates */
				AddUpdatesUser(users, usercnt, From, MessageData, MessageLength);
				break;
			case SC_REQUEST_TRAIN_DATA:
				/* user has requested train data */
				TOS_SendTrainData(traincnt, trains, From, pipe);
				break;
			case SC_ADD_TRAIN:
				/* Add a train to the train list */
				AddTrain(trains, traincnt, MessageData, MessageLength);
				TOS_SendTrainData(traincnt, trains, users, usercnt, pipe);
				break;
			case SC_REMOVE_TRAIN:
				/* Remove a train from the track */
				RemoveTrain(trains, traincnt, MessageData, MessageLength);
				TOS_SendTrainData(traincnt, trains, users, usercnt, pipe);
				break;
			case SC_RESOURCE_DATA:
				/* 1 - is section */
				/* 2 - is node    */
				
				res = NULL;
				unsigned long reslen;

				if(TOS_ReadResourceData((unsigned long&)res, reslen, MessageData, MessageLength))
				{
					unsigned long ri;
					for(ri=0;ri<reslen;ri++)
					{
						if(res[ri].type == 1)
						{
							myTrack.SetSectionOwner(res[ri].id, res[ri].owner);
						}
						else if(res[ri].type == 2)
						{
							myTrack.SetNodeOwner(res[ri].id, res[ri].owner);
						}
						else
						{
							/* unknown resource type */
						}
					}
				}
				delete res;
				break;
			}
		}
	}




}

bool RemoveTrain(Train * trains, unsigned long traincnt, char * data, unsigned long length)
{
	/* MessageID */
	/* [TrainID (x2)] */

	char logmessage[255];
	/* add to users list */
	if(length != 2)
	{
		strcpy(logmessage, "Remove Train Message is the wrong length.");
		WriteLog(logmessage);
		return false;
	}

	if(traincnt == 0)
	{
		strcpy(logmessage, "No trains to remove, skipping.");
		WriteLog(logmessage);
		return false;
	}

	/*get id*/
	unsigned long id = data[0]*256;
	id += data[1];


	bool found = false;
	unsigned long i;
	for(i=0;i<traincnt;i++)
	{
		if(trains[i].id == id)
		{
			found = true;
			traincnt--;
		}
		if(found)
		{
			trains[i] = trains[i+1];
		}
	}

	sprintf(logmessage, "Train %i was removed from the system.", id );
	WriteLog(logmessage);
	return true;
}


bool AddTrain(Train * trains, unsigned long& traincnt, char * data, unsigned long length)
{
	/* MessageID */
	/* [TrainID (x2)][SectionID(x2)][Slope(x1)][SectionPos(x8)] */


	char logmessage[255];
	/* add to users list */
	if(length != 13)
	{
		strcpy(logmessage, "Add Train Message is the wrong length.");
		WriteLog(logmessage);
		return false;
	}

	if(traincnt >= MAX_TRAINS)
	{
		strcpy(logmessage, "Max trains exceeded.");
		WriteLog(logmessage);
		return false;
	}

	/* get id*/
	unsigned long id = data[0] * 256;
	id += data[1];

	/* get section id */
	unsigned long section = data[2] * 256;
	section += data[3];

	/* get section position */
	double pos;
	unsigned int i;
	for(i=0;i<8;i++)
	{
		((char*)(&pos))[i] = data[5+i];
	}

	/* get slope */
	char slope = data[4];

	trains[traincnt].id = id;
	trains[traincnt].section = section;
	trains[traincnt].sectionpos = pos;
	trains[traincnt].slope = slope;
	trains[traincnt].speed = 0;
	trains[traincnt].targetspeed = 0;

	traincnt++;

	sprintf(logmessage, "Train %i was added on section %i, position %f.", id,section, pos );
	WriteLog(logmessage);

	return true;
}


bool AddUpdatesUser(char  users[][CLIENT_SIZE_CLIENTNAME], unsigned long& usercnt, char * from, char * data, unsigned long length)
{
	char logmessage[255];
	/* add to users list */
	if(length != 2)
	{
		strcpy(logmessage, "RequestTrainUpdates Message is the wrong length.");
		WriteLog(logmessage);
		return false;
	}

	if(usercnt >= MAX_UPDATE_USERS)
	{
		strcpy(logmessage, "Max update users exceeded.");
		WriteLog(logmessage);
		return false;
	}

	/* copy data into first available posistion */
	strcpy(users[usercnt], from);

	usercnt++;

	//sprintf(logmessage, "Client %s registered for train updates ever %i milliseconds", from, users[usercnt-1].interval );
	//WriteLog(logmessage);
	return true;

}



bool SetTrainSpeed(char * data, unsigned long length, Train * trains, unsigned long traincnt)
{
	/* Message Format */
	/* [Train ID (x2)][Speed (x4)] */

	char logmessage[255];
	if(length != 7) 
	{
		strcpy(logmessage, "SetTrainSpeed Message is the wrong length.");
		WriteLog(logmessage);
		return false;
	}

	/* Get Train ID */
	unsigned long trainid = data[0] * 256;
	trainid += data[1];

	/* Get trian Speed */
	unsigned long speed = data[2] * 0x01000000;
	speed += data[3] * 0x00010000;
	speed += data[4] * 0x00000100;
	speed += data[5];

	int direction;
	if(data[6]==1)
		direction = 1;
	else 
		direction = -1;

	/* Find train */
	unsigned long i;
	for(i = 0; i < traincnt; i++)
	{
		if(trains[i].id == trainid)
		{
			trains[i].targetspeed = speed * direction;
			/* Set trains speed on the DCC */
			unsigned long dccspeed;
			if(speed >= 0)
			{
				dccspeed = int(float(speed/100) *  FULLDCCSPEED);
				direction = 1;
			}
			else
			{
				dccspeed = int(float(-speed/100) *  FULLDCCSPEED);
				direction = 0;
			}

			/* dont set train speed here, must aquire resources and all that */
			//TOS_SetTrainSpeedDCC(trains[i].id, dccspeed, direction, pipe);

			
			/* finished, return true */
							
			sprintf(logmessage, "Train %i was set to speed %i.", trainid, speed);
			WriteLog(logmessage);

			return true;
		}
	}

	/*train not found*/

	sprintf(logmessage, "Train %i is not in the system.", trainid);
	WriteLog(logmessage);
	return false;
}

	



void WriteLog(char * message)
{

	char LogFile[255];
	strcpy(LogFile, LOGFILE);

	ofstream log;
	log.open(LogFile,ios::app);

	cerr << message << "\n";

	if(!log)
	{
		cerr << "Failed to write to log.\n";
		return;
	}
    char dbuffer [9];
    char tbuffer [9];
    _strdate( dbuffer );
    _strtime( tbuffer );
    

	log << dbuffer << " " << tbuffer << " - " << message << "\n";

	return;

}