// hello.cpp - implementation of CHelloWindow
#include <afxwin.h>
#include <windows.h>
#include <strstrea.h>
#include <process.h>
#include <afxdlgs.h>
#include <math.h>
#include "menu_ids.h"
#include "resource.h"
#include "dialogs.h"
#include "..\..\tos client api\track.h"
#include "..\..\tos client api\kmp_client_api.h"
#include "..\..\tos client api\tos_api.h"

#include "hellowindow.h"


//#define NOSERVER

CHelloWindow::CHelloWindow()
{ 
	//AfxMessageBox("CHelloWindow::CHelloWindow - Create()");

	/* CREATE WINDOW */
	Create(NULL, "Lab 2", WS_OVERLAPPEDWINDOW,
		CRect(0, 0, 800, 600), NULL, "MyMenu" );
 
	/* DEVICE CONTEXT OF WINDOW */
	m_pDC = new CClientDC(this);

	/* CREATE A MEMORY DEVICE CONTEXT TO DRAW TRACK VIEWPORT ON */
	m_pMemDC = new CDC;
	if(m_pMemDC == NULL)
	{
		SendMessage(WM_CLOSE);
		return;
	}

	//if(!m_pMemDC->CreateCompatibleDC(m_pMemDC))
	if(!m_pMemDC->CreateCompatibleDC(m_pDC))
	{
		/* FAILURE TO INITIATE */
		SendMessage(WM_CLOSE);
		return;
	}
	
	
	/* TRACK VIEWPORT RECTANGLE */
	m_rTrackView = CRect(100,0,788, 400);


	/* CREATE BITMAP FOR MEMORY DEVICE CONTEXT */
	m_pBM = new CBitmap;
	if(m_pBM == NULL)
	{
		SendMessage(WM_CLOSE);
		return;
	}

	if(!m_pBM->CreateCompatibleBitmap(m_pDC, m_rTrackView.Width(), m_rTrackView.Height()))
	{
		SendMessage(WM_CLOSE);
		return;
	}

	/* SELECT BITMAP */
	m_pMemDC->SelectObject(m_pBM);

	/* Start Message Loop Timer */
	timer = SetTimer(1, 200, NULL);

	if(timer == 0)
	{
		AfxMessageBox("Could not create timer.");
		DestroyWindow();
	}

	m_bAddTrain = false;
	m_iScale = 7;

	m_iAddHoverLR = 0;
	m_iAddHoverSection = 0;
	m_bAddIsHover = false;

	m_pTrains =  NULL;
}

afx_msg void CHelloWindow::OnClearTrack()
{
	myTrack.Clear();
	DrawTrackViewport();
}

afx_msg void CHelloWindow::OnExit()
{
	SendMessage (WM_CLOSE);
}



CHelloWindow::~CHelloWindow()
{
	delete m_pDC;
	delete m_pMemDC;
	delete m_pBM;

	

}

afx_msg void CHelloWindow::OnPaint()
{

	//CFrameWnd::OnPaint();
	
	CPaintDC dc(this);

	/* TRACK VIEWPORT */
	dc.BitBlt(m_rTrackView.left, m_rTrackView.top, m_rTrackView.Width(), m_rTrackView.Height(), m_pMemDC, 0,0, SRCCOPY);


}

afx_msg void CHelloWindow::OnSize(UINT nType, int cx, int cy)
{
	m_rTrackView.right = cx;
	m_rTrackView.bottom = cy - 200;

	if(m_rTrackView.right <= m_rTrackView.left ) 
	{
		m_rTrackView.right = m_rTrackView.left + 1;
	}
	if(m_rTrackView.bottom <=  m_rTrackView.top)
	{
		m_rTrackView.bottom = m_rTrackView.top + 1;
	}

	CBitmap tempbmp;

	m_pMemDC->SelectObject(tempbmp);

	delete m_pBM;


	m_pBM = new CBitmap;
	if(m_pBM == NULL)
	{
		SendMessage(WM_CLOSE);
		return;
	}

	if(!m_pBM->CreateCompatibleBitmap(m_pDC, m_rTrackView.Width(), m_rTrackView.Height()))
	{
		SendMessage(WM_CLOSE);
		return;
	}

	m_pMemDC->SelectObject(m_pBM);

	DrawTrackViewport();

}

void CHelloWindow::DrawTrackViewport()
{

	//AfxMessageBox("HI");

	CBrush * brush = new CBrush(RGB(255,255,255));
	CBrush * oldbrush;

	CFont * font, * oldfont;
	font = new CFont;

	font->CreateFont(10, 7, 0, 0, FW_NORMAL, 
						FALSE, FALSE,0, 0, 
						OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
						DEFAULT_QUALITY,DEFAULT_PITCH,"Courier");

	oldfont = m_pMemDC->SelectObject(font);

	oldbrush = m_pMemDC->SelectObject(brush);
	
	m_pMemDC->Rectangle(0,0,m_rTrackView.Width(), m_rTrackView.Height());

	m_pMemDC->SetBkColor(RGB(255,255,255));
	m_pMemDC->SetTextColor(RGB(255,0,0));

	m_pMemDC->DrawText("TRACK VIEWPORT", CRect(5,5,10,10), DT_NOCLIP);

	//m_pMemDC->TextOut(0,30, "TRACK VIEWPORT");

	/* DRAW TRACK DATA HERE */
	//int scale = 25;

	CBrush * sbrush = new CBrush(RGB(0,255,255));
	m_pMemDC->SelectObject(sbrush);
	CPen * spen, * oldpen, * ownpen;

	spen = new CPen(PS_SOLID, 4, RGB(25,255,25));

	ownpen = new CPen(PS_SOLID, 4, RGB(255, 50, 50));

	oldpen = m_pMemDC->SelectObject(spen);

	CBitmap * bmleft = new CBitmap;
	bmleft->LoadBitmap(IDB_ADD_LEFT);

	CBitmap * bmright = new CBitmap;
	bmright->LoadBitmap(IDB_ADD_RIGHT);

	CBrush * brleft = new CBrush(bmleft);
	CBrush * brright = new CBrush(bmright);

	unsigned int i;
	for(i=0;i<myTrack.GetSectionCount();i++)
	{
		Section sec = myTrack.GetSectionByIndex(i);

		int x1 = sec.Ax * m_iScale;
		int y1 = sec.Ay * m_iScale;
		int x2 = sec.Bx * m_iScale;
		int y2 = sec.By * m_iScale;

		char sstr[50];
		itoa(sec.ID, sstr, 10);

		m_pMemDC->DrawText(sstr, strlen(sstr), CRect(x1+((x2-x1)/2), y1+((y2-y1)/2)-20, x1+((x2-x1)/2) + 20, y1),DT_NOCLIP);
		


		if(sec.OwnerID == 0xffffffff)
		{
			m_pMemDC->SelectObject(spen);
		}
		else
		{
			m_pMemDC->SelectObject(ownpen);
		}

//		if(sec.Radius == 0)
//		{
			
			m_pMemDC->MoveTo(x1, y1);
			m_pMemDC->LineTo(x2, y2);
//		}
//		else
//		{
//			int startangle = int(float(atan((-(y1-y2))/((x1-x2))) / (2*3.14)) * 360);
//			m_pMemDC->MoveTo(x1, y1);
//			int startx = x1 + (x2-x1)/2;
//			int starty = y1 + (y2-y1)/2;
//			m_pMemDC->AngleArc(starty, starty,sec.Radius*scale, startangle, 180);
//
//		}

		if(m_bAddTrain)
		{

			/* Draw add buttons */

			CRect * addleft = new CRect(x1+((x2-x1)/2)-30, y1+((y2-y1)/2)-30, x1+((x2-x1)/2)-8, y1+((y2-y1)/2)-22);
			CRect * addright = new CRect(x1+((x2-x1)/2)+8, y1+((y2-y1)/2)-30, x1+((x2-x1)/2)+30, y1+((y2-y1)/2)-22);

			/* if hover draw rectangle */
			if(m_bAddIsHover)
			{
				if(m_iAddHoverLR == 1 && m_iAddHoverSection == i)
				{
					m_pMemDC->Rectangle(addleft);
				}
				else if(m_iAddHoverLR == -1 && m_iAddHoverSection == i)
				{
					m_pMemDC->Rectangle(addright);
				}
			}
			/* Draw left button */
			/* Set brush origin */

			m_pMemDC->SelectObject(oldbrush);
			brleft->UnrealizeObject();
			m_pMemDC->SetBrushOrg(addleft->left, addleft->top);
			m_pMemDC->SelectObject(brleft);
			m_pMemDC->FillRect(addleft, brleft);

			/* Draw Right Button */
			m_pMemDC->SelectObject(oldbrush);
			brright->UnrealizeObject();
			m_pMemDC->SetBrushOrg(addright->left, addright->top);
			m_pMemDC->SelectObject(brright);
			m_pMemDC->FillRect(addright, brright);


			delete addleft;
			delete addright;
		}


	}

	CPen * trainpen = new CPen(PS_SOLID, 2, RGB(0, 100, 240));

	m_pMemDC->SelectObject(trainpen);
	if(m_pTrains != NULL)
		{
		for(i=0;i<m_iTrains;i++)
		{
			unsigned long sid = m_pTrains[i].section;
			Section tsec = myTrack.GetSectionById(sid);
			int x, y;

			//int len = sqrt((tsec.Bx-tsec.Ax)*(tsec.Bx-tsec.Ax) + (tsec.By-tsec.Ay)*(tsec.By-tsec.Ay));

			//float ratio = m_pTrains[i].sectionpos / len;

			//x = tsec.Bx + ((tsec.Bx-tsec.Ax)* ratio);
			//y = tsec.By + ((tsec.By-tsec.Ay)* ratio);

			//x = tsec.Ax+(tsec.Bx - tsec.Ax);
			//y = tsec.By+(tsec.By - tsec.Ay);

			//m_pMemDC->Ellipse(x*m_iScale - 10, y*m_iScale - 10, x*m_iScale + 10, y*m_iScale + 10); 
			m_pMemDC->Ellipse(tsec.Ax*m_iScale - 10, tsec.Ay*m_iScale - 10, tsec.Ax*m_iScale + 10, tsec.Ay*m_iScale + 10); 
		}
	}

	
	m_pMemDC->SelectObject(oldbrush);
	m_pMemDC->SelectObject(oldfont);
	m_pMemDC->SelectObject(oldpen);
	delete brush;
	delete font;
	delete sbrush;
	delete spen;
	delete ownpen;
	delete bmleft;
	delete brleft;
	delete brright;
	delete bmright;

	Invalidate();

}


afx_msg void CHelloWindow::OnTimer( UINT nIDEvent )
{

	#ifndef NOSERVER
	if(Connect)
	{
		
		/*Connect to server*/
		pipe = ConnectToServer(UIPipeName);
		
		
		if(pipe == INVALID_HANDLE_VALUE)
		{	
			AfxMessageBox("Failed to connect to server.");

			return;
		}
		Connect = false;
	}
	#endif
	
	char From[CLIENT_SIZE_CLIENTNAME];
	unsigned long ServiceCode;
	char MessageData[CLIENT_SIZE_MESSAGE];
	unsigned long MessageLength;

	Resource * res;

	/* Get next message */
	while(GetMessageFromPeer(From, ServiceCode, MessageData, MessageLength, pipe) >=0)
	{

		switch(ServiceCode)
		{
		case SC_TRACK_DATA:
			AfxMessageBox("Recieved Track Data Message.");
			
			TOS_ReadTrackData(&myTrack, MessageData, MessageLength);
			DrawTrackViewport();
			break;
		case SC_AIU_UPDATES:
			unsigned long index, sid;
			bool val;
			TOS_ReadAIUUpdate(MessageData, MessageLength, index, val);
			if(index >= myTrack.GetSensorCount())
			{
				break;
			}
			char message[56];
			sid = myTrack.GetSensorByIndex(index).ID;
			sprintf(message, "Sensor %i is now %i.", sid, val);
			AfxMessageBox(message);
			break;
		case SC_DCC_READY:
			AfxMessageBox("DCC Ready");
			break;
		case SC_DCC_NOT_READY:
			AfxMessageBox("DCC Not Ready");
			break;
		case SC_RESOURCE_GRANT:

			/* Message Format */
			/* [TrainID(x2)][Type(x1)][ResourceID(x2)] */
			unsigned long tid;
			unsigned char type;
			unsigned long rid;
			tid = MessageData[0] * 256;
			tid += MessageData[1];
			type = MessageData[2];
			rid = MessageData[3] * 256;
			rid += MessageData[4];

			char rmess[50];
			sprintf(rmess, "Train %i has been given resource %i, type %i.", tid, rid, type);
			AfxMessageBox(rmess);

			break;
		case SC_RESOURCE_DENY:

			/* Message Format */
			/* [TrainID(x2)][Type(x1)][ResourceID(x2)] */
			unsigned long tid2;
			unsigned char type2;
			unsigned long rid2;
			tid2 = MessageData[0] * 256;
			tid2 += MessageData[1];
			type2 = MessageData[2];
			rid2 = MessageData[3] * 256;
			rid2 += MessageData[4];

			char rmess2[50];
			sprintf(rmess2, "Train %i has been denied resource %i, type %i.", tid2, rid2, type2);
			AfxMessageBox(rmess2);
			break;

		case SC_RESOURCE_DATA:
			/* 1 - is section */
			/* 2 - is node    */
			//AfxMessageBox("Recieved Resource Data.");
			res = NULL;
			unsigned long reslen;

			if(TOS_ReadResourceData((unsigned long&)res, reslen, MessageData, MessageLength))
			{
				unsigned long ri;
				for(ri=0;ri<reslen;ri++)
				{
					if(res[ri].type == 1)
					{
						myTrack.SetSectionOwner(res[ri].id, res[ri].owner);
					}
					else if(res[ri].type == 2)
					{
						myTrack.SetNodeOwner(res[ri].id, res[ri].owner);
					}
					else
					{
						/* unknown resource type */
					}
				}
				DrawTrackViewport();
			}
			delete res;
			break;

		case SC_TRAIN_DATA:
			AfxMessageBox("Recieved Train Data.");
			if(m_pTrains != NULL)
			{
				delete[] m_pTrains;
			}
			TOS_ReadTrainData((unsigned long&)m_pTrains,m_iTrains, MessageData, MessageLength);
			DrawTrackViewport();
			Invalidate(false);

			break;

		default:
			AfxMessageBox("Recieved Unknown Message.");
			break;

		}
		

		Sleep(0);
	}

	return;

}


afx_msg void CHelloWindow::OnTestTrackManRequestData()
{

	//AfxMessageBox("Sending Request");

	if(!TOS_RequestTrackData(pipe))
	{
		AfxMessageBox("Send Failed.");
	}



}

afx_msg void CHelloWindow::OnTestTrackManRequestUpdates()
{
	if(!TOS_RequestTrackDataUpdates(pipe))
	{
		AfxMessageBox("SendFailed");
	}

}

afx_msg void CHelloWindow::OnLoadTrackFile()
{

	CFileDialog file(true);

	if(file.DoModal() == IDOK)
	{
		char filename[255];
		strcpy(filename, file.GetPathName());
		TOS_RequestLoadTrackFromFile(filename, pipe);

	}

}

afx_msg void CHelloWindow::OnTestDccRequestUpdates()
{

	if(!TOS_RequestDCCUpdates(pipe))
	{
		AfxMessageBox("SendFailed");
	}

}

afx_msg void CHelloWindow::OnTestDccInit()
{
	char port[20];
	strcpy(port, "COM1");
	if(!TOS_InitDCC(port, pipe))
	{
		AfxMessageBox("SendFailed");
	}
}

afx_msg void CHelloWindow::OnTestDccTrain48()
{
	DCCSpeedTest * test = new DCCSpeedTest(NULL);

	if(test->DoModal() == IDOK)
	{
		unsigned long speed = test->value;
		unsigned long train = test->train;
		unsigned char dir   = test->direction;


		if(!TOS_SetTrainSpeedDCC(train, speed, dir, pipe))
		{
			AfxMessageBox("SendFailed");
		}
	}
	delete test;

}

afx_msg void CHelloWindow::OnTestDccSetTurn()
{
	DCCSwitchTest * test = new DCCSwitchTest(NULL);

	if(test->DoModal() == IDOK)
	{
		unsigned long add = test->add;
		unsigned char val = test->value;

		if(!TOS_SetTurnout(add, val, pipe))
		{
			AfxMessageBox("SendFailed");
		}
	}

	delete test;
}

afx_msg void CHelloWindow::OnTestDccCab()
{

	DCCCab * c = new DCCCab(NULL, pipe);
	
	c->DoModal();


	delete c;

}

afx_msg void CHelloWindow::OnTestRequestResource()
{
	ResourceRequestTest * test = new ResourceRequestTest(NULL);

	if(test->DoModal() == IDOK)
	{
		unsigned long id = test->id;
		unsigned long owner = test->owner;
		unsigned char type = test->type;

		TOS_RequestOwnership(owner, type, id, pipe);
	}

	delete test;
}

afx_msg void CHelloWindow::OnTestReleaseResource()
{

	ResourceRequestTest * test = new ResourceRequestTest(NULL);

	if(test->DoModal() == IDOK)
	{
		unsigned long id = test->id;
		//unsigned long owner = test->owner;
		unsigned char type = test->type;

		TOS_ReleaseOwnership(type, id, pipe);
	}

	delete test;
}

afx_msg void CHelloWindow::OnTestResourceUpdates()
{
	TOS_RequestResourceUpdates(pipe);
	
}

afx_msg void CHelloWindow::OnAddTrain()
{
	m_bAddTrain = !m_bAddTrain;
	DrawTrackViewport();
	Invalidate(false);

}

afx_msg void CHelloWindow::OnMouseMove( UINT flags, CPoint point )
{

	if(m_bAddTrain)
	{
		point.x = point.x - m_rTrackView.left;
		point.y = point.y - m_rTrackView.top;

		bool washover = m_bAddIsHover;
		m_bAddIsHover = false;
		unsigned long i;
		for(i=0;i<myTrack.GetSectionCount();i++)
		{
			Section sec = myTrack.GetSectionByIndex(i);

			int x1 = sec.Ax * m_iScale;
			int y1 = sec.Ay * m_iScale;
			int x2 = sec.Bx * m_iScale;
			int y2 = sec.By * m_iScale;

			CRect * addleft = new CRect(x1+((x2-x1)/2)-30, y1+((y2-y1)/2)-30, x1+((x2-x1)/2)-8, y1+((y2-y1)/2)-22);
			CRect * addright = new CRect(x1+((x2-x1)/2)+8, y1+((y2-y1)/2)-30, x1+((x2-x1)/2)+30, y1+((y2-y1)/2)-22);

			if(addleft->PtInRect(point))
			{
				/*mouse is in rectangle*/
				m_iAddHoverSection = i;
				m_iAddHoverLR		= 1;
				m_bAddIsHover = true;
				break;
			}
			else if(addright->PtInRect(point))
			{
				/* mouse in rectangel*/

				m_iAddHoverSection = i;
				m_iAddHoverLR		= -1;
				m_bAddIsHover = true;
				break;
			}

		}
		if(washover != m_bAddIsHover)
		{
			DrawTrackViewport();
			Invalidate(false);
		}


	}

}

afx_msg void CHelloWindow::OnLButtonUp( UINT flags, CPoint point )
{
	if(m_bAddTrain)
	{
		point.x = point.x - m_rTrackView.left;
		point.y = point.y - m_rTrackView.top;

	
		unsigned long i;
		for(i=0;i<myTrack.GetSectionCount();i++)
		{
			Section sec = myTrack.GetSectionByIndex(i);

			int x1 = sec.Ax * m_iScale;
			int y1 = sec.Ay * m_iScale;
			int x2 = sec.Bx * m_iScale;
			int y2 = sec.By * m_iScale;

			CRect * addleft = new CRect(x1+((x2-x1)/2)-30, y1+((y2-y1)/2)-30, x1+((x2-x1)/2)-8, y1+((y2-y1)/2)-22);
			CRect * addright = new CRect(x1+((x2-x1)/2)+8, y1+((y2-y1)/2)-30, x1+((x2-x1)/2)+30, y1+((y2-y1)/2)-22);

			addleft->NormalizeRect();
			addright->NormalizeRect();

			if(addleft->PtInRect(point))
			{
				/*mouse is in rectangle*/

				AddTrainDlg * add = new AddTrainDlg(NULL);
				if(add->DoModal() == IDOK)
				{
					if(x1<x2)
					{
						/*slope = -1, front of train pointing towards 0 */
						/* add in middle */
						double pos = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
						TOS_AddTrain(add->id, sec.ID, -1, pos, pipe);
					}
					else
					{
						/*slope = -1, front of train pointing towards 0 */
						/* add in middle */
						double pos = sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1));
						TOS_AddTrain(add->id, sec.ID, 1, pos, pipe);
					}

				}
				delete add;
				m_bAddTrain = !m_bAddTrain;
				DrawTrackViewport();
				Invalidate(false);

				break;
			}
			else if(addright->PtInRect(point))
			{
				/* mouse in rectangel*/

				AddTrainDlg * add = new AddTrainDlg(NULL);
				if(add->DoModal() == IDOK)
				{
					if(x1<x2)
					{
						/*slope = -1, front of train pointing towards 0 */
						/* add in middle */
						double pos = (sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1)))/m_iScale;
						TOS_AddTrain(add->id, sec.ID, -1, pos, pipe);
					}
					else
					{
						/*slope = -1, front of train pointing towards 0 */
						/* add in middle */
						double pos = (sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1)))/m_iScale;
						TOS_AddTrain(add->id, sec.ID, 1, pos, pipe);
					}

				}
				m_bAddTrain = !m_bAddTrain;
				DrawTrackViewport();
				Invalidate(false);

				delete add;
				break;
			}

		}

	}

}

afx_msg void CHelloWindow::OnTestTrainUpdates()
{

	TOS_RequestTrainUpdates(100, pipe);

}


BEGIN_MESSAGE_MAP(CHelloWindow, CFrameWnd)

	ON_COMMAND(IDM_ONEXIT,					OnExit)
	ON_COMMAND(IDM_TM_REQUESTDATA,			OnTestTrackManRequestData)
	ON_COMMAND(IDM_TRACKMAN_REQUESTUPDATES, OnTestTrackManRequestUpdates)
	ON_COMMAND(IDM_CLEAR_TRACK,				OnClearTrack)
	ON_COMMAND(IDM_LOAD_TRACK_FILE,			OnLoadTrackFile)
	ON_COMMAND(IDM_TEST_DCC_REQUEST_UPDATES,OnTestDccRequestUpdates)
	ON_COMMAND(IDM_TEST_DCC_INIT,			OnTestDccInit)
	ON_COMMAND(ID_TEST_DCC_TRAIN,			OnTestDccTrain48)
	ON_COMMAND(IDM_TEST_DCC_SET_TURN,		OnTestDccSetTurn)
	ON_COMMAND(IDM_TEST_DCC_CAB,			OnTestDccCab)
	ON_COMMAND(IDM_TEST_REQUEST_RESOURCE,	OnTestRequestResource)
	ON_COMMAND(IDM_TEST_RELEASE_RESOURCE,	OnTestReleaseResource)
	ON_COMMAND(IDD_TEST_RESOURCE_UPDATES,	OnTestResourceUpdates)
	ON_COMMAND(IDM_ADD_TRAIN,				OnAddTrain)
	ON_COMMAND(IDM_TEST_TRAIN_UPDATES,		OnTestTrainUpdates)
	ON_WM_MOUSEMOVE( )
	ON_WM_LBUTTONUP( )
	ON_WM_TIMER()
	ON_WM_PAINT()
	ON_WM_SIZE()

END_MESSAGE_MAP()